package cn.palmte.work.controller.backend;

import cn.palmte.work.bean.ApproveStatusEnum;
import cn.palmte.work.bean.BudgetBean;
import cn.palmte.work.bean.EstimateBean;
import cn.palmte.work.bean.FinalBean;
import cn.palmte.work.model.Project;
import cn.palmte.work.model.ProjectBudgetPlanDetail;
import cn.palmte.work.service.ProjectBudgetService;
import cn.palmte.work.service.ProjectEstimateService;
import cn.palmte.work.service.ProjectFinalSevice;
import cn.palmte.work.service.ProjectService;
import cn.palmte.work.utils.FreeMarkerUtil;
import cn.palmte.work.utils.InterfaceUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Map;

@Controller
@RequestMapping("/project/final")
public class ProjectFinalController extends BaseController{

    @Autowired
    private ProjectFinalSevice projectFinalSevice;

    @Autowired
    private ProjectService projectService;

    @Autowired
    private ProjectEstimateService projectEstimateService;

    @Autowired
    private ProjectBudgetService projectBudgetService;

    @RequestMapping("/edit")
    public String budget(@RequestParam("id") int id, Map<String, Object> model) {
        Project project = projectService.getProject(id);
        List<ProjectBudgetPlanDetail> projectBudgetPlanDetails = projectBudgetService.getProjectBudgetPlanDetails(project);
        model.put("project", project);
        model.put("estimateBean", projectEstimateService.getEstimate(project));
        model.put("budgetBean", projectBudgetService.getBudget(project));
        model.put("finalBean",new FinalBean());
        //现金表
        model.put("cashFlowBean", projectBudgetService.getCashFlowBean(project, projectBudgetPlanDetails));
        //freemarker可以利用的静态方法
        model.put("Utils", FreeMarkerUtil.fromStaticPackage("cn.palmte.work.utils.Utils"));
        return "admin/project_final_edit";
    }

    @RequestMapping("/save")
    public void estimateAddSave(Project project, FinalBean finalBean, Map<String, Object> model) {
        projectFinalSevice.save(project,finalBean);

    }

}
