package cn.palmte.work.service;


import cn.palmte.work.bean.ApproveStatusEnum;
import cn.palmte.work.config.activiti.ActConstant;
import cn.palmte.work.utils.ActUtil;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;


/**
 * 流程回调脚本 参数必须为Map
 */
@Service
public class ActCallbackScript {
    private static final Logger logger = LoggerFactory.getLogger(ActCallbackScript.class);
    @Autowired
    private ActUtil actUtil;
    @Autowired
    private ProjectInstanceService projectInstanceService;

    /**
     * 更新流程审批通过
     *
     * @param map
     */
    public void updateApproveStatus(Map map) {
        logger.info("--- updateApproveStatus--- : {} ", map);
        //String startUserId = (String) map.get(ActConstant.START_PROCESS_USERID);
        String procInsId = (String) map.get(ActConstant.PROC_INS_ID);
        String procDefKey = (String) map.get(ActConstant.PROC_DEF_KEY);
        logger.info(" updateApproveStatus procInsId:{}, procDefKey:{}", procInsId, procDefKey);

        int projectId = actUtil.getProjectId(procInsId);
        if (projectId > 0) {
            projectInstanceService.updateApproveStatus(projectId, ApproveStatusEnum.APPROVAL_PASSED, procDefKey);
        }

    }


}
